//+------------------------------------------------------------------+
//|                                              Test_CCIOnArray.mq5 |
//|                                                          Integer |
//|                          https://login.mql5.com/ru/users/Integer |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link      "https://login.mql5.com/ru/users/Integer"
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_plots   1
//--- plot Label1
#property indicator_label1  "Label1"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- input parameters
input int            CCIPeriod  =  14;
input ENUM_MA_METHOD CCIMethod  =  MODE_SMA;
//--- indicator buffers
double         CCIBuffer[];
double         MABuffer[];
double         data[];

#include <IncOnArray/IncCCIOnArray.mqh>
CCCIOnArray cci;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   cci.Init(CCIPeriod,CCIMethod);

//--- indicator buffers mapping
   SetIndexBuffer(0,CCIBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,MABuffer,INDICATOR_CALCULATIONS);
   SetIndexBuffer(2,data,INDICATOR_CALCULATIONS);

   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,cci.BarsRequired());
   PlotIndexSetString(0,PLOT_LABEL,cci.Name());
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
   int start;
   if(prev_calculated>0)
     {
      start=prev_calculated-1;
     }
   else
     {
      start=0;
     }
   for(int i=start;i<rates_total;i++)
     {
      data[i]=price[i];
     }

   cci.Solve(rates_total,prev_calculated,data,MABuffer,CCIBuffer);

   return(rates_total);
  }
//+------------------------------------------------------------------+
